﻿# fuelle-Schritt-4 Alternative ohne-elif-else.py
# schrittweise Erarbeitung:
### Schritt 4:
# das neue Stück passt in den Container
# einfüllen und weiter suchen

# Prädikat zum Testen, ob der Container voll ist.
def istVoll(container, fassungsvermoegen):
    return fassungsvermoegen==sum(container)

### Hilfsfunktion zum Testen der Überfüllung
def istZuVoll(container, fassungsvermoegen):
    return fassungsvermoegen<sum(container)

# Globale Variable für die Stücke:
stuecke=[30,30,30,20,20,20,20]

# Erarbeitung des Funktionskopfes
def fuelle(stuecke, container, fassungsvermoegen):
    if len(stuecke)==0:
        return False
    if istVoll(container, fassungsvermoegen):
        return container
    if istZuVoll(stuecke[:1]+container, fassungsvermoegen):
        return fuelle(stuecke[1:], container, fassungsvermoegen)
    return fuelle(stuecke[1:],
                  container+stuecke[:1],
                  fassungsvermoegen)

### Tests:
def ausgabe(stuecke, container, fassungsvermoegen):
    print(stuecke, 'Fassungsvermoegen:', fassungsvermoegen)
    print( 'Ergebnis: ',
           fuelle(stuecke, container, fassungsvermoegen) )
    print('')
    
ausgabe( stuecke, [30,30,20], 80 ) # Erfolg
ausgabe( [30,30], [30,30], 80 ) # wird zu voll
ausgabe( [], [30,30], 80 ) # Misserfolg
ausgabe( stuecke, [], 80 ) # "Standard" ergibt noch Fehler
##print('Aber was ist mit:')
##ausgabe( stuecke, [], 90 )
##ausgabe( stuecke, [], 100 )
